#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#define INMAX 100
#define ENGSIZE 1000
#define STRLEN 256


float fin[100], fout[2000], tin[100], tout[2000];
float impulse, mp, tb;
int nin, nout;



/****************************************************************************/
int interpolate( fin, tin, nin, fout, tout)
float fin[], tin[], fout[], tout[];
int nin;
{
/* Does linear interpolation in an array of points */
#define ENGSIZE 1000
#define NUMBER 500
#define DELTAT0 .002

float tb, deltat, slope, intercept, t, fwork, deltat1;
int j, i, m, nout;



tb=tin[nin-1];
deltat=tb/NUMBER;
nout = NUMBER;
if (deltat > DELTAT0)
  {
  nout = tb/DELTAT0;
  if (nout > ENGSIZE) nout = ENGSIZE;
  deltat = tb/((float) nout);
  }
t=0.0;
nout = 0;
for(i=1; i<nin; i++)
  {
  fwork=tin[i]-tin[i-1];
  m = (int)(fwork/deltat + 0.5);
  /* see comment before for staement */
  if (tin[i] == tb) m++;
  deltat1= fwork/((float) m);
  t = tin[i-1];
  slope = (fin[i]-fin[i-1])/fwork;
  intercept=fin[i-1];
  /* note: last point in interval not done except in last interval */
  for(j =1; j< m; j++)
    {
    fout[nout] = slope*deltat*j + intercept;
    tout[nout] = t;
    t +=deltat1;
    nout++;
    }
  }
  nout--;
return(nout);
}
/****************************************************************************/
void get_line(cp)
char *cp;
{
  int c;

  for (;;) {
    c = getchar();
    if ((c >= 'a') && (c <= 'z'))
	c = c + 'A' - 'a';
    if (c == EOF || c == '\n') {
      *cp = 0;
      return;
    }
    *cp++ = c;
  }
}

/****************************************************************************/
void main()
{
int i, inlen, numint;
char linein[STRLEN], infilename[STRLEN], outfilename[STRLEN];
FILE *ifp, *ofp, *fopen();

clrscr();

ifp=NULL;
while (ifp == NULL)
  {
  printf("Input File: :" );
  get_line(infilename);
  ifp=fopen(infilename, "r");
  }

ofp=NULL;
while (ofp == NULL)
  {
  printf("output File: :" );
  get_line(outfilename);
  ofp=fopen(outfilename, "w");
  }
fgets(linein, STRLEN, ifp);
fprintf(ofp,"%s ",linein);
fscanf(ifp,"%f %f %f %i", &impulse, &mp, &tb, &numint);
for(nin=0; nin<=numint; nin++)
  {
  fscanf(ifp,"%f %f ", &tin[nin], &fin[nin]);
  }
  fclose(ifp);
nout = interpolate( fin, tin, nin, fout, tout);

fout[nout-1]=fin[nin-1];
tout[nout-1]=tb;

fprintf(ofp,"%f %f %f %i \n",impulse, mp, tb, nout-1);

for(i=0; i<nout; i++)
  {
  fprintf(ofp,"%f %f 1\n", fout[i], tout[i]);
  }
fclose(ofp);

return;
}